/******************************************************************************
  Copyright 2013 Tom Cornall

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.  
 ******************************************************************************/
#ifndef KBD_H
#define KBD_H

#include <LUFA/Drivers/USB/USB.h>
#include <stdlib.h>
#include "eeprom.h"
#include "mcp4726.h"
#include "sr.h"

#define KBD_COLS 23
#define KBD_ROWS 4

#define KBD_DEBOUNCE_LEN 6
#define KBD_DEBOUNCE_MIN 0
#define KBD_DEBOUNCE_MAX (KBD_DEBOUNCE_LEN - 1)
#define KBD_DEBOUNCE_THRESH (KBD_DEBOUNCE_LEN / 2 - 1)

#define KBD_SC_IGNORED 0
#define KBD_SC_CAL_HI  1
#define KBD_SC_CAL_LO  2

extern int8_t kbd[KBD_COLS][KBD_ROWS];
extern uint8_t kbdMatrix[KBD_COLS][KBD_ROWS];

void kbdCalibrate(void);
void kbdFillReport(USB_KeyboardReport_Data_t *kbdReport);
void kbdLoadMatrix(void);
void kbdStoreMatrix(void);
void kbdScan(void);

#endif
